#ifndef _AWACS_H_
#define _AWACS_H_

#include <asm/dbdma.h>
#include "awacs_defs.h"

#define MAX_DMACOUNT		0xfff0

extern int		awacs_busy;

extern inline void init_dma(struct dbdma_cmd *cp, int cmd,
			    void *buf, int count)
{
	st_le16(&cp->req_count, count);
	st_le16(&cp->command, cmd);
	st_le32(&cp->phy_addr, virt_to_phys(buf));
	cp->xfer_status = 0;
}

extern inline void init_dma_rx(struct dbdma_cmd *cp, int cmd,
			    void *buf, int count)
{
	st_le16(&cp->req_count, count);
	st_le16(&cp->command, cmd);
	st_le32(&cp->phy_addr, virt_to_bus(buf));
	cp->xfer_status = 0;
}

/* ************** Function Prototypes *************** */

int awacs_set_speed (int arg);
short awacs_set_channels (int arg);
unsigned int awacs_set_bits (int arg);
int awacs_set_swap (int arg);
int awacs_audio_ioctl (int dev, unsigned int cmd, caddr_t arg, int local);
void awacs_audio_reset (int dev);
int awacs_audio_open (int dev, int mode);
void awacs_audio_close (int dev);
void awacs_audio_output_block (int dev, unsigned long buf, 
				      int count, int intrflag, int restart_dma);
void awacs_audio_start_input (int dev, unsigned long buf, 
				     int count, int intrflag, int restart_dma);
int awacs_audio_prepare_for_input (int dev, int bsize, int bcount);
int awacs_audio_prepare_for_output (int dev, int bsize, int bcount);
void awacs_txdma_intr(int irq, void *dev_id, struct pt_regs *regs);
void awacs_rxdma_intr(int irq, void *dev_id, struct pt_regs *regs);
int awacs_beep(void);
int awacs_send_data(char *buf, int len);
unsigned char *awacs_convert(char *buf, int *len);
int awacs_pcm_read_test(void);
void awacs_halt_input (int dev);
void awacs_halt_output (int dev);
void awacs_pcm_init (struct address_info *hw_config);
void awacs_pcm_interrupt (unsigned char status, int cause);
void awacs_txdma_intr(int irq, void *dev_id, struct pt_regs *regs);
void awacs_rxdma_intr(int irq, void *dev_id, struct pt_regs *regs);

/* ************************************************** */


#endif /* _AWACS_H_ */
